cookutils view cook @ rev 226

cook: display time for pkglist
author Christophe Lincoln <pankso@slitaz.org>
date Thu May 26 22:11:24 2011 +0200 (2011-05-26)
parents 0d02e63da3c2
children 5e9d0bdd4830
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifing any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
11 [ -f "cook.conf" ] && . ./cook.conf
13 # Share DB and status with the Cooker.
14 activity="$CACHE/activity"
15 command="$CACHE/command"
16 broken="$CACHE/broken"
17 blocked="$CACHE/blocked"
19 # Old style compatibility
20 SOURCES_REPOSITORY=$SRC
22 #
23 # Functions
24 #
26 usage() {
27 cat << EOT
29 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
31 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
32 usage|help $(gettext "Display this short usage.")
33 setup $(gettext "Setup your build environment.")
34 test $(gettext "Test environment and cook a package.")
35 list-wok $(gettext "List packages in the wok.")
36 search $(gettext "Simple packages search function.")
37 new $(gettext "Create a new package with a receipt".)
38 list $(gettext "Cook a list of packages.")
39 clean-wok $(gettext "Clean-up all packages files.")
40 clean-src $(gettext "Clean-up all packages sources.")
41 pkglist $(gettext "Create all packages.* lists.")
43 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
44 --clean|-c Cook : $(gettext "clean the package in the wok.")
45 --install|-i Cook : $(gettext "cook and install the package.")
46 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
47 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
48 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
49 --interactive|-x Cook : $(gettext "create a receipt interactively.")
50 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
52 EOT
53 exit 0
54 }
56 # Be sure we're root.
57 check_root() {
58 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
59 }
61 separator() {
62 echo "================================================================================"
63 }
65 status() {
66 echo -en "\\033[70G[ "
67 if [ $? = 0 ]; then
68 echo -en "\\033[1;32mOK"
69 else
70 echo -en "\\033[1;31mFailed"
71 fi
72 echo -e "\\033[0;39m ]"
73 }
75 # Log activities, we want first letter capitalized.
76 log() {
77 grep ^[A-Z] | \
78 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
79 }
81 # We don't want these escapes in web interface.
82 clean_log() {
83 sed -i -e s'|\[70G\[ \[1;32m| |' \
84 -e s'|\[0;39m \]||' $LOGS/$pkg.log
85 }
87 # Log broken packages.
88 broken() {
89 if ! grep -q "^$pkg$" $broken; then
90 echo "$pkg" >> $broken
91 fi
92 }
94 # Be sure package exists in wok.
95 check_pkg_in_wok() {
96 if [ ! -d "$WOK/$pkg" ]; then
97 gettext -e "\nUnable to find package in the wok:"
98 echo -e " $pkg\n" && exit 1
99 fi
100 }
102 if_empty_value() {
103 if [ -z "$value" ]; then
104 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
105 exit 1
106 fi
107 }
109 # Initialize files used in $CACHE
110 init_db_files() {
111 gettext "Creating directories structure in:"; echo " $SLITAZ"
112 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
113 gettext "Creating DB files in:"; echo " $CACHE"
114 for f in $activity $command $broken $blocked
115 do
116 touch $f
117 done
118 }
120 # QA: check a receipt consistency before building.
121 receipt_quality() {
122 gettext -e "QA: checking package receipt...\n"
123 unset online
124 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
125 online="online"
126 fi
127 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
128 do
129 unset value
130 value=$(grep ^$var= $receipt | cut -d \" -f 2)
131 case "$var" in
132 PACKAGE|VERSION|SHORT_DESC)
133 if_empty_value ;;
134 CATEGORY)
135 [ -z "$value" ] && value="empty"
136 valid="base-system x-window utilities network graphics \
137 multimedia office development system-tools security games \
138 misc meta non-free"
139 if ! echo "$valid" | grep -q -w "$value"; then
140 gettext "QA: unknown category:"; echo -e " $value\n"
141 exit 1
142 fi ;;
143 WEB_SITE)
144 # We don't check WGET_URL since if dl is needed it will fail.
145 # Break also if we're not online. Here error is not fatal.
146 if_empty_value
147 [ -z "$online" ] || break
148 if ! busybox wget -T 12 -s $value 2>/dev/null; then
149 gettext "QA: Unable to reach:"; echo -e " $value"
150 fi ;;
151 esac
152 done
153 }
155 # Executed before sourcing a receipt.
156 unset_receipt() {
157 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
158 }
160 # Paths used in receipt and by cook itself.
161 set_paths() {
162 pkgdir=$WOK/$PACKAGE
163 src=$pkgdir/source/$PACKAGE-$VERSION
164 taz=$pkgdir/taz
165 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
166 fs=$pack/fs
167 stuff=$pkgdir/stuff
168 install=$pkgdir/install
169 if [ "$WANTED" ]; then
170 src=$WOK/$WANTED/source/$WANTED-$VERSION
171 install=$WOK/$WANTED/install
172 wanted_stuff=$WOK/$WANTED/stuff
173 fi
174 # Old way compatibility.
175 _pkg=$install
176 }
178 # Create source tarball when URL is a SCM.
179 create_tarball() {
180 gettext "Creating tarball: "; echo "$tarball"
181 if [ "$LZMA_SRC" ]; then
182 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
183 else
184 tar cjf $tarball $pkgsrc || exit 1
185 mv $tarball $SRC && rm -rf $pkgsrc
186 fi
187 }
189 # Get package source. For SCM we are in cache so clone here and create a
190 # tarball here.
191 get_source() {
192 pwd=$(pwd)
193 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
194 tarball=$pkgsrc.tar.bz2
195 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
196 case "$WGET_URL" in
197 http://*|ftp://*)
198 # Busybox Wget is better!
199 busybox wget -T 12 -c -P $SRC $WGET_URL || \
200 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
201 https://*)
202 wget -c --no-check-certificate -P $SRC $WGET_URL || \
203 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
204 hg*|mercurial*)
205 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
206 url=${WGET_URL#hg|}
207 else
208 url=${WGET_URL#mercurial|}
209 fi
210 gettext -e "Getting source from Hg...\n"
211 echo "URL: $url"
212 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
213 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
214 create_tarball ;;
215 git*)
216 url=${WGET_URL#git|}
217 gettext -e "Getting source from Git...\n"
218 echo "URL: $url"
219 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
220 if [ "$BRANCH" ]; then
221 echo "Git branch: $BRANCH"
222 cd $pkgsrc && git checkout $BRANCH && cd ..
223 fi
224 create_tarball ;;
225 cvs*)
226 url=${WGET_URL#cvs|}
227 mod=$PACKAGE
228 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
229 gettext -e "Getting source from CVS...\n"
230 echo "URL: $url"
231 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
232 gettext "Cloning to: "; echo "$pwd/$mod"
233 cvs -d:$url co $mod && mv $mod $pkgsrc
234 create_tarball ;;
235 svn*|subversion*)
236 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
237 url=${WGET_URL#svn|}
238 else
239 url=${WGET_URL#subversion|}
240 fi
241 gettext -e "Getting source from SVN...\n"
242 echo "URL: $url"
243 if [ "$BRANCH" ]; then
244 echo t | svn co $url -r $BRANCH $pkgsrc
245 else
246 echo t | svn co $url $pkgsrc
247 fi
248 create_tarball ;;
249 *)
250 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
251 tee -a $LOGS/$PACKAGE.log
252 exit 1 ;;
253 esac
254 }
256 # Extract source package.
257 extract_source() {
258 if [ ! -s "$SRC/$TARBALL" ]; then
259 local url
260 url="http://mirror.slitaz.org/sources/packages"
261 url=$url/${TARBALL:0:1}/$TARBALL
262 gettext "Getting source from mirror:"; echo " $url"
263 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
264 fi
265 gettext "Extracting:"; echo " $TARBALL"
266 case "$TARBALL" in
267 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
268 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
269 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
270 *.tar) tar xf $SRC/$TARBALL ;;
271 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
272 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
273 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
274 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
275 *) cp $SRC/$TARBALL $(pwd) ;;
276 esac
277 }
279 # Display cooked package summary.
280 summary() {
281 cd $WOK/$pkg
282 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
283 fs=$(du -sh taz/* | awk '{print $1}')
284 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
285 files=$(cat taz/$pkg-*/files.list | wc -l)
286 cookdate=$(date "+%Y-%m-%d %H:%M")
287 sec=$time
288 div=$(($time / 60))
289 [ "$div" != 0 ] && min="~ ${div}m"
290 gettext "Summary for:"; echo " $PACKAGE $VERSION"
291 separator
292 [ "$prod" ] && echo "Produced : $prod"
293 cat << EOT
294 Packed : $fs
295 Compressed : $size
296 Files : $files
297 Cook time : ${sec}s $min
298 Cook date : $cookdate
299 $(separator)
300 EOT
301 }
303 # Display debugging error info.
304 debug_info() {
305 echo -e "\nDebug information"
306 separator
307 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
308 for error in \
309 ERROR "No package" "cp: can't" "can't open" "can't cd" \
310 "error:" "fatal error:"
311 do
312 fgrep "$error" $LOGS/$pkg.log
313 done
314 separator && echo ""
315 }
317 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
318 # so some packages need to copy these files with the receipt and genpkg_rules.
319 copy_generic_files()
320 {
321 # $LOCALE is set in cook.conf
322 if [ "$LOCALE" ]; then
323 if [ -d "$_pkg/usr/share/locale" ]; then
324 mkdir -p $fs/usr/share/locale
325 for i in $LOCALE
326 do
327 if [ -d "$_pkg/usr/share/locale/$i" ]; then
328 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
329 fi
330 done
331 fi
332 fi
334 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
335 if [ "$GENERIC_PIXMAPS" != "no" ]; then
336 if [ -d "$_pkg/usr/share/pixmaps" ]; then
337 mkdir -p $fs/usr/share/pixmaps
338 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
339 $fs/usr/share/pixmaps 2>/dev/null
340 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
341 $fs/usr/share/pixmaps 2>/dev/null
342 fi
344 # Custom or homemade PNG pixmap can be in stuff.
345 if [ -f "$stuff/$PACKAGE.png" ]; then
346 mkdir -p $fs/usr/share/pixmaps
347 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
348 fi
349 fi
351 # Desktop entry (.desktop).
352 if [ -d "$_pkg/usr/share/applications" ]; then
353 cp -a $_pkg/usr/share/applications $fs/usr/share
354 fi
356 # Homemade desktop file(s) can be in stuff.
357 if [ -d "$stuff/applications" ]; then
358 mkdir -p $fs/usr/share
359 cp -a $stuff/applications $fs/usr/share
360 fi
361 if [ -f "$stuff/$PACKAGE.desktop" ]; then
362 mkdir -p $fs/usr/share/applications
363 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
364 fi
365 }
367 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
368 # as removing uneeded files like in Python packages.
369 strip_package()
370 {
371 gettext "Executing strip on all files..."
372 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
373 do
374 if [ -d "$dir" ]; then
375 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
376 fi
377 done
378 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
379 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
380 status
382 # Remove Python .pyc and .pyo from packages.
383 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
384 gettext "Removing Python compiled files..."
385 find $fs -type f -name "*.pyc" -delete 2>/dev/null
386 find $fs -type f -name "*.pyo" -delete 2>/dev/null
387 status
388 fi
390 # Remove Perl perllocal.pod and .packlist from packages.
391 if echo "$DEPENDS" | fgrep -q "perl"; then
392 gettext "Removing Perl compiled files..."
393 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
394 find $fs -type f -name ".packlist" -delete 2>/dev/null
395 status
396 fi
397 }
399 # Remove installed deps.
400 remove_deps() {
401 # Now remove installed build deps.
402 diff="$CACHE/installed.cook.diff"
403 if [ -s "$CACHE/installed.cook.diff" ]; then
404 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
405 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
406 gettext "Build dependencies to remove:"; echo " $nb"
407 gettext "Removing:"
408 for dep in $deps
409 do
410 echo -n " $dep"
411 echo 'y' | tazpkg remove $dep >/dev/null
412 done
413 echo -e "\n"
414 # Keep the last diff for debug and info.
415 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
416 fi
417 }
419 # The main cook function.
420 cookit() {
421 echo "Cook: $PACKAGE $VERSION"
422 separator
423 set_paths
424 [ "$QA" ] && receipt_quality
425 cd $pkgdir
426 rm -rf install taz source
428 # Disable -pipe if less than 512Mb free RAM.
429 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
430 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
431 gettext -e "Disabling -pipe compile flag: $free RAM\n"
432 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
433 CXXFLAGS="${CXXFLAGS/-pipe}" && \
434 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
435 fi
436 unset free
438 # Export flags and path to be used by make
439 DESTDIR=$pkgdir/install
440 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
442 # Check for build deps and handle implicit depends of *-dev packages
443 # (ex: libusb-dev :: libusb).
444 rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
445 touch $CACHE/installed.local $CACHE/installed.web
446 [ "$BUILD_DEPENDS" ] && gettext -e "Checking build dependencies...\n"
447 for dep in $BUILD_DEPENDS
448 do
449 implicit=${dep%-dev}
450 for i in $dep $implicit
451 do
452 if [ ! -f "$INSTALLED/$i/receipt" ]; then
453 # Try local package first. In some cases implicit doesn't exist, ex:
454 # libboost-dev exists but not libboost, so check if we got vers.
455 unset vers
456 vers=$(grep ^VERSION= $WOK/$i/receipt 2>/dev/null | cut -d '"' -f 2)
457 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
458 echo $i-$vers.tazpkg >> $CACHE/installed.local
459 else
460 # Priority to package version in wok (maybe mor up-to-date)
461 # tha the mirrored one.
462 if [ "$vers" ]; then
463 if fgrep -q $i-$vers $DB/packages.list; then
464 echo $i >> $CACHE/installed.web
465 else
466 # So package exists in wok but not available.
467 gettext "Missing dep (wok/pkg):"; echo " $i $vers"
468 echo $i >> $CACHE/missing.dep
469 fi
470 else
471 # Package is not in wok but may be in repo.
472 if fgrep -q $i-$vers $DB/packages.list; then
473 echo $i >> $CACHE/installed.web
474 else
475 echo "ERROR: unknow dep $i" && exit 1
476 fi
477 fi
478 fi
479 fi
480 done
481 done
483 # Get the list of installed packages
484 cd $INSTALLED && ls -1 > $CACHE/installed.list
486 # Have we a missing build dep to cook ?
487 if [ -s "$CACHE/missing.dep" ] && [ "$AUTO_COOK" ]; then
488 gettext -e "Auto cook config is set : AUTO_COOK\n"
489 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
490 for i in $(uniq $CACHE/missing.dep)
491 do
492 (gettext "Building dep (wok/pkg) :"; echo " $i $vers") | \
493 tee -a $LOGS/$PACKAGE.log.$$
494 cook $i || (echo -e "ERROR: can't cook dep '$i'\n" && \
495 fgrep "remove: " $LOGS/$i.log && \
496 fgrep "Removing: " $LOGS/$i.log && echo "") | \
497 tee -a $LOGS/$PACKAGE.log.$$ && break
498 done
499 rm -f $CACHE/missing.dep
500 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
501 fi
503 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
504 # is enabled and cook fails we have ERROR in log, if no auto cook we have
505 # missing dep in cached file.
506 if fgrep -q "ERROR:" $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
507 [ -s "$CACHE/missing.dep" ] && nb=$(cat $CACHE/missing.dep | wc -l)
508 echo "ERROR: missing dep $nb" && exit 1
509 fi
511 # Install local packages.
512 cd $PKGS
513 for i in $(uniq $CACHE/installed.local)
514 do
515 gettext "Installing dep (pkg/local):"; echo " $i"
516 tazpkg install $i >/dev/null
517 done
519 # Install web or cached packages (if mirror is set to $PKGS we only
520 # use local packages).
521 for i in $(uniq $CACHE/installed.web)
522 do
523 gettext "Installing dep (web/cache):"; echo " $i $vers"
524 tazpkg get-install $i >/dev/null
525 done
527 # If a cook failed deps are removed.
528 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
529 [ ! -s "installed.cook.diff" ] && \
530 busybox diff installed.list installed.cook > installed.cook.diff
531 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
533 # Get source tarball and make sure we have source dir named:
534 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
535 # tarball if it exists.
536 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
537 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
538 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
539 LZMA_SRC=""
540 else
541 get_source || exit 1
542 fi
543 fi
544 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
545 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
546 extract_source || exit 1
547 if [ "$LZMA_SRC" ]; then
548 cd $pkgdir/source
549 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
550 mv tmp tmp-1 && mkdir tmp
551 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
552 fi
553 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
554 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
555 fi
556 fi
557 cd $pkgdir/source/tmp
558 # Some archives are not well done and don't extract to one dir (ex lzma).
559 files=$(ls | wc -l)
560 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
561 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
562 mv * ../$PACKAGE-$VERSION
563 cd .. && rm -rf tmp
564 fi
566 # Execute receipt rules.
567 if grep -q ^compile_rules $receipt; then
568 gettext -e "Executing: compile_rules\n"
569 [ -d "$src" ] && cd $src
570 compile_rules $@ || exit 1
571 # Stay compatible with _pkg
572 [ -d "$src/_pkg" ] && mv $src/_pkg $install
573 # QA: compile_rules success so valid.
574 mkdir -p $install
575 else
576 # QA: No compile_rules so no error, valid.
577 mkdir -p $install
578 fi
579 separator && echo ""
580 }
582 # Cook quality assurance.
583 cookit_quality() {
584 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
585 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
586 fi
587 # ERROR can be echoed any time in cookit()
588 if fgrep -q ERROR: $LOGS/$pkg.log; then
589 debug_info | tee -a $LOGS/$pkg.log
590 rm -f $command && exit 1
591 fi
592 }
594 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
595 # but it doesn't handle EXTRAVERSION.
596 packit() {
597 set_paths
598 echo "Pack: $PACKAGE $VERSION"
599 separator
600 if grep -q ^genpkg_rules $receipt; then
601 gettext -e "Executing: genpkg_rules\n"
602 cd $pkgdir
603 mkdir -p $fs && ( set -e; genpkg_rules ) || echo -e \
604 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
605 fi
607 # First QA check to stop now if genpkg_rules failed.
608 if fgrep -q ERROR: $LOGS/$pkg.log; then
609 exit 1
610 fi
612 cd $taz
613 for file in receipt description.txt
614 do
615 [ ! -f "../$file" ] && continue
616 gettext "Copying"; echo -n " $file..."
617 cp -f ../$file $pack && chown 0.0 $pack/$file && status
618 done
619 copy_generic_files
621 # Create files.list with redirecting find output.
622 gettext "Creating the list of files..." && cd $fs
623 find . -type f -print > ../files.list
624 find . -type l -print >> ../files.list
625 cd .. && sed -i s/'^.'/''/ files.list
626 status
628 # Strip and stuff files.
629 strip_package
631 # Md5sum of files.
632 gettext "Creating md5sum of files..."
633 while read file; do
634 [ -L "fs$file" ] && continue
635 [ -f "fs$file" ] || continue
636 case "$file" in
637 /lib/modules/*/modules.*|*.pyc) continue;;
638 esac
639 md5sum "fs$file" | sed 's/ fs/ /'
640 done < files.list > md5sum
641 status
642 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
643 description.txt 2> /dev/null | awk \
644 '{ sz=$1 } END { print sz }')
646 # Build cpio archives.
647 gettext "Compressing the fs... "
648 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
649 rm -rf fs
650 status
651 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
652 md5sum description.txt 2> /dev/null | awk \
653 '{ sz=$1 } END { print sz }')
654 gettext "Updating receipt sizes..."
655 sed -i s/^PACKED_SIZE.*$// receipt
656 sed -i s/^UNPACKED_SIZE.*$// receipt
657 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
658 status
660 # Set extra version.
661 if [ "$EXTRAVERSION" ]; then
662 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
663 sed -i s/^EXTRAVERSION.*$// receipt
664 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
665 status
666 fi
668 # Compress.
669 gettext "Creating full cpio archive... "
670 find . -print | cpio -o -H newc --quiet > \
671 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
672 status
673 gettext "Restoring original package tree... "
674 unlzma -c fs.cpio.lzma | cpio -idm --quiet
675 status
676 rm fs.cpio.lzma && cd ..
678 # QA and give info.
679 tazpkg=$(ls *.tazpkg)
680 packit_quality
681 separator && gettext "Package:"; echo -e " $tazpkg\n"
682 }
684 # Verify package quality and consistency.
685 packit_quality() {
686 #gettext "QA: Checking for broken link..."
687 #link=$(find $fs/usr -type l -follow)
688 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
689 #status
691 # Exit if any error found in log file.
692 if fgrep -q ERROR: $LOGS/$pkg.log; then
693 rm -f $command && exit 1
694 fi
696 gettext "QA: Checking for empty package..."
697 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
698 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
699 echo -e "\nERROR: empty package"
700 rm -f $command && exit 1
701 else
702 # Ls sort by name so the first file is the one we want.
703 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
704 status
705 if [ -f "$old" ]; then
706 echo -n "Removing old: $(basename $old)"
707 rm -f $old && status
708 fi
709 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
710 sed -i /^${pkg}$/d $broken
711 fi
712 }
714 #
715 # Commands
716 #
718 case "$1" in
719 usage|help|-u|-h)
720 usage ;;
721 list-wok)
722 gettext -e "\nList of packages in:"; echo " $WOK"
723 separator
724 cd $WOK && ls -1
725 separator
726 echo -n "Packages: " && ls | wc -l
727 echo "" ;;
728 search)
729 # Just a simple search function, we dont need more actually.
730 query="$2"
731 gettext -e "\nSearch results for:"; echo " $query"
732 separator
733 cd $WOK && ls -1 | grep "$query"
734 separator && echo "" ;;
735 setup)
736 # Setup a build environment
737 check_root
738 echo "Cook: setting up the environment" | log
739 gettext -e "\nSetting up your environment\n"
740 separator && cd $SLITAZ
741 init_db_files
742 gettext -e "Checking for packages to install...\n"
743 for pkg in $SETUP_PKGS
744 do
745 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
746 done
748 # Handle --options
749 case "$2" in
750 --wok|-w)
751 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
752 tazpkg get-install mercurial
753 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
754 hg clone $WOK_URL ;;
755 esac
757 # SliTaz group and permissions
758 if ! grep -q ^slitaz /etc/group; then
759 gettext -e "Adding group: slitaz\n"
760 addgroup slitaz
761 fi
762 gettext -e "Setting permissions for slitaz group...\n"
763 chown -R root.slitaz $SLITAZ
764 chmod -R g+w $SLITAZ
765 separator
766 gettext -e "All done, ready to cook packages :-)\n\n" ;;
767 test)
768 # Test a cook environment.
769 echo "Cook test: testing the cook environment" | log
770 [ ! -d "$WOK" ] && exit 1
771 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
772 cook cooktest ;;
773 new)
774 # Create the package folder and an empty receipt.
775 pkg="$2"
776 [ "$pkg" ] || usage
777 echo ""
778 if [ -d "$WOK/$pkg" ]; then
779 echo -n "$pkg " && gettext "package already exists."
780 echo -e "\n" && exit 1
781 fi
782 gettext "Creating"; echo -n " $WOK/$pkg"
783 mkdir $WOK/$pkg && cd $WOK/$pkg && status
784 gettext "Preparing the package receipt..."
785 cp $DATA/receipt .
786 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
787 status && echo ""
789 # Interactive mode, asking and seding.
790 case "$3" in
791 --interactive|-x)
792 gettext -e "Entering interactive mode...\n"
793 separator
794 echo "Package : $pkg"
795 # Version.
796 echo -n "Version : " ; read anser
797 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
798 # Category.
799 echo -n "Category : " ; read anser
800 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
801 # Short description.
802 echo -n "Short desc : " ; read anser
803 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
804 # Maintainer.
805 echo -n "Maintainer : " ; read anser
806 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
807 # Web site.
808 echo -n "Web site : " ; read anser
809 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
810 echo ""
811 # Wget URL.
812 echo "Wget URL to download source tarball."
813 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
814 echo -n "Wget url : " ; read anser
815 sed -i s#'WGET_URL=\"$TARBALL\"'#"WGET_URL=\"$anser\""# receipt
816 # Ask for a stuff dir.
817 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
818 if [ "$anser" = "y" ]; then
819 echo -n "Creating the stuff directory..."
820 mkdir $WOK/$pkg/stuff && status
821 fi
822 # Ask for a description file.
823 echo -n "Are you going to write a description ? (y/N) : " ; read anser
824 if [ "$anser" = "y" ]; then
825 echo -n "Creating the description.txt file..."
826 echo "" > $WOK/$pkg/description.txt && status
827 fi
828 separator
829 gettext -e "Receipt is ready to use.\n"
830 echo "" ;;
831 esac ;;
832 list)
833 # Cook a list of packages (better use the Cooker since it will order
834 # packages before executing cook).
835 check_root
836 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
837 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
838 echo -e " $2\n" && exit 1
839 echo "Cook list starting: $2" | log
840 for pkg in $(cat $2)
841 do
842 cook $pkg || broken
843 done ;;
844 clean-wok)
845 check_root
846 gettext -e "\nCleaning all packages files..."
847 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
848 status && echo "" ;;
849 clean-src)
850 check_root
851 gettext -e "\nCleaning all packages sources..."
852 rm -rf $WOK/*/source
853 status && echo "" ;;
854 pkglist)
855 # Create suitable packages list for TazPKG and only for built packages.
856 [ "$2" ] && PKGS="$2"
857 [ ! -d "$PKGS" ] && \
858 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
859 time=$(date +%s)
860 echo "cook:pkglist" > $command
861 echo "Cook pkglist: Creating all packages lists" | log
862 gettext -e "\nCreating lists for:"; echo " $PKGS"
863 separator
864 gettext "Cook pkglist tarted at: "; date "+%H:%M"
865 cd $PKGS
866 rm -f packages.*
867 gettext "Creating: packages.list "
868 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
869 echo $(du -sh $PKGS/packages.list | awk '{print $1}')
870 gettext "Creating: packages.md5 "
871 md5sum *.tazpkg > $PKGS/packages.md5
872 echo $(du -sh $PKGS/packages.md5 | awk '{print $1}')
873 gettext -e "Creating lists from:"; echo " $WOK"
874 cd $WOK
875 for pkg in *
876 do
877 unset_receipt
878 . $pkg/receipt
879 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
880 # packages.desc lets us search easily in DB
881 cat >> $PKGS/packages.desc << EOT
882 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
883 EOT
884 # packages.txt used by tazpkg and tazpkg-web also to provide
885 # a human readable package list with version and description.
886 cat >> $PKGS/packages.txt << EOT
887 $PACKAGE
888 ${VERSION}$EXTRAVERSION
889 $SHORT_DESC
890 $PACKED_SIZE ($UNPACKED_SIZE installed)
892 EOT
893 # packages.equiv is used by tazpkg install to check depends.
894 for i in $PROVIDE; do
895 DEST=""
896 echo $i | fgrep -q : && DEST="${i#*:}:"
897 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
898 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
899 $PKGS/packages.equiv
900 else
901 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
902 fi
903 done
904 # files.list provides a list of all packages files.
905 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
906 $PKGS/files.list
907 fi
908 done
909 cd $PKGS
911 # Display list size.
912 gettext "Done: packages.desc "
913 echo $(du -sh $PKGS/packages.desc | awk '{print $1}')
914 gettext "Done: packages.txt "
915 echo $(du -sh $PKGS/packages.txt | awk '{print $1}')
916 gettext "Done: packages.equiv "
917 echo $(du -sh $PKGS/packages.equiv | awk '{print $1}')
919 # files.list.lzma
920 gettext "Creating: files.list.lzma "
921 lzma e files.list files.list.lzma
922 rm -f files.list
923 echo $(du -sh $PKGS/files.list.lzma | awk '{print $1}')
925 separator
926 nb=$(ls $PKGS/*.tazpkg | wc -l)
927 time=$(($(date +%s) - $time))
928 echo -e "Packages: $nb - Time: $time\n"
929 rm -f $command ;;
930 *)
931 # Just cook and generate a package.
932 check_root
933 time=$(date +%s)
934 pkg="$1"
935 [ -z "$pkg" ] && usage
936 receipt="$WOK/$pkg/receipt"
937 check_pkg_in_wok && echo ""
939 # Display and log info if cook process stopped.
940 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
941 tee -a $LOGS/$pkg.log' INT
943 # Skip blocked, 3 lines also for the Cooker.
944 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
945 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
946 fi
948 # Log and source receipt.
949 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
950 echo "cook:$pkg" > $command
951 unset inst
952 unset_receipt
953 . $receipt
955 # Handle --options
956 case "$2" in
957 --clean|-c)
958 gettext -e "Cleaning:"; echo -n " $pkg"
959 cd $WOK/$pkg && rm -rf install taz source
960 status && echo "" && exit 0 ;;
961 --install|-i)
962 inst='yes' ;;
963 --getsrc|-gs)
964 gettext "Getting source for:"; echo " $pkg"
965 separator && get_source
966 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
967 --block|-b)
968 gettext "Blocking:"; echo -n " $pkg"
969 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
970 status && echo "" && exit 0 ;;
971 --unblock|-ub)
972 gettext "Unblocking:"; echo -n " $pkg"
973 sed -i "/^${pkg}$/"d $blocked
974 status && echo "" && exit 0 ;;
976 esac
978 # Check if wanted is built now so we have separate log files.
979 if [ "$WANTED" ]; then
980 if grep -q "^$WANTED$" $blocked; then
981 echo "WANTED package is blocked: $WANTED" | tee $LOGS/$pkg.log
982 echo "" && rm -f $command && exit 1
983 fi
984 if grep -q "^$WANTED$" $broken; then
985 echo "WANTED package is broken: $WANTED" | tee $LOGS/$pkg.log
986 echo "" && rm -f $command && exit 1
987 fi
988 if [ ! -d "$WOK/$WANTED/install" ]; then
989 cook "$WANTED" || exit 1
990 fi
991 fi
993 # Cook and pack or exit on error and log everything.
994 cookit $@ 2>&1 | tee $LOGS/$pkg.log
995 remove_deps | tee -a $LOGS/$pkg.log
996 cookit_quality
997 packit 2>&1 | tee -a $LOGS/$pkg.log
998 clean_log
1000 # Exit if any error in packing.
1001 if grep -q ^ERROR $LOGS/$pkg.log; then
1002 debug_info | tee -a $LOGS/$pkg.log
1003 rm -f $command && exit 1
1004 fi
1006 # Time and summary
1007 time=$(($(date +%s) - $time))
1008 summary | tee -a $LOGS/$pkg.log
1009 echo ""
1011 # Install package if requested
1012 if [ "$inst" ]; then
1013 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
1014 cd $PKGS && tazpkg install \
1015 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
1016 else
1017 gettext -e "Unable to install package, build has failed.\n\n"
1018 exit 1
1019 fi
1020 fi
1021 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
1022 # You want automation: use the Cooker Build Bot.
1023 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
1024 rm -f $command ;;
1025 esac
1027 exit 0